// Warning: Using Sega's SBL propriety code. Do not release

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cmp.h"

#define PROG_NAME "LMDCMP"
#define VER_NAME "1.01"
#define COPYRIGHT_YEAR "2004"

FILE *fp;
FILE *outfp;

unsigned char *cmp_buffer;
unsigned char *dcmp_buffer;

/*
unsigned char system_num=8;

unsigned long systemdatsize[22] = {
0x24000, // 0
0x2000,  // 1
0x18000, // 2
0x8000,  // 3
0x200,   // 4
0x200,   // 5
0x200,   // 6
0x4000,  // 7
0x1000,  // 8
0x8000,  // 9
0x800,   // 10
0x1000,  // 11
0x400,   // 12
0x100,   // 13
0x100,   // 14
0x200,   // 15
0x200,   // 16
0x200,   // 17
0x1200,  // 18
0x300,   // 19
0x500,   // 20
0x3000   // 21
};
*/

//////////////////////////////////////////////////////////////////////////////

void ProgramUsage()
{
   char prog[]=PROG_NAME;
   printf("%s v%s - by Cyber Warrior X (c)%s\n", PROG_NAME, VER_NAME, COPYRIGHT_YEAR);
   printf("usage: %s [options] <filename>\n", strlwr(prog));
   printf("  Ex: %s -s table.tbl d00.dat script%%64.txt new-d00.dat\n", prog);
   printf("options:\n"
      "\t-a\tType of compression is assumed to be in header, auto detect it\n"
      "\t-1\tByte stream compression(default)\n"
      "\t-2\tWord stream compression\n"
      "\t-4\tDouble word stream compression\n");
   exit (1);
}

//////////////////////////////////////////////////////////////////////////////

void cleanup()
{
   if (fp) fclose(fp);
   if (outfp) fclose(outfp);
   if (cmp_buffer) free(cmp_buffer);
   if (dcmp_buffer) free(dcmp_buffer);
}

//////////////////////////////////////////////////////////////////////////////

int main(int argc, char *argv[])
{
   char *filename=NULL;
   char out_filename[_MAX_PATH];
   unsigned long f_size=0;
   unsigned long temp_long=0;
   unsigned char *work_buffer;
   int mode=1;

   atexit(cleanup);

   if (argc < 2)
   {
      ProgramUsage();
   }

   for (int i = 1; i < argc; i++)
   {
      if (_stricmp(argv[i], "-a") == 0)
         mode = 0;
      else if (_stricmp(argv[i], "-1") == 0)
         mode = 1;
      else if (_stricmp(argv[i], "-2") == 0)
         mode = 2;
      else if (_stricmp(argv[i], "-4") == 0)
         mode = 3;
      else
      {
         filename = argv[i];
         break;
      }
   }


   printf("%s v%s - by Cyber Warrior X(c)%s\n", PROG_NAME, VER_NAME, COPYRIGHT_YEAR);

   if ((fp = fopen(filename, "rb")) == NULL)
   {
      printf("Unable to open %s\n", filename);
      exit(1);
   }

   fseek(fp, 0, SEEK_END);
   f_size = ftell(fp);
   fseek(fp, 0, SEEK_SET);

   // allocate buffer for file
   if ((cmp_buffer = (unsigned char *)malloc(f_size)) == NULL)
   {
      printf("Unable to allocate buffer\n");
      exit(1);
   }

   // allocate buffer for decompression
   if ((dcmp_buffer = (unsigned char *)malloc(0x100000)) == NULL)
   {
      printf("Unable to allocate buffer for decompression\n");
      exit(1);
   }

   // read in file
   fread((void *)cmp_buffer, 1, f_size, fp);
   fclose(fp);

   work_buffer = dcmp_buffer;

   // Decompress data
   unsigned long dcmp_size = 0x100000;

   switch (mode)
   {
      case 0:
         if (cmp_decompress((cmp_buffer + temp_long), &work_buffer, 0x100000, &dcmp_size) != ERR_OK)
         {
            printf("Error decompressing data\n");
            exit(1);
         }
         break;
      case 1:
         if (cmp_decompress_byte_stream((cmp_buffer + temp_long), &work_buffer, 0x100000, &dcmp_size) != ERR_OK)
         {
            printf("Error decompressing data\n");
            exit(1);
         }
         break;
      case 2:
         if (cmp_decompress_word_stream((cmp_buffer + temp_long), &work_buffer, 0x100000, &dcmp_size) != ERR_OK)
         {
            printf("Error decompressing data\n");
            exit(1);
         }
         break;
         break;
      case 3:
         if (cmp_decompress_dword_stream((cmp_buffer + temp_long), &work_buffer, 0x100000, &dcmp_size) != ERR_OK)
         {
            printf("Error decompressing data\n");
            exit(1);
         }
         break;
         break;
   }

   strcpy(out_filename, filename);
   char *out_filename_p = strrchr(out_filename, '.');
   strcpy(out_filename_p, ".bin");

   if ((outfp = fopen(out_filename, "wb")) == NULL)
   {
      printf("Unable to open %s for writing\n", out_filename);
      exit(1);
   }

   fwrite((void *)dcmp_buffer, 1, dcmp_size, outfp);
   fclose(outfp);
   printf("done.\n");

   return 0;
}

//////////////////////////////////////////////////////////////////////////////
